var NAVTREE =
[
  [ "RTI Connext DDS Micro", "index.html", [
    [ "Product Overview", "product_overview.html", [
      [ "What Is RTI Connext DDS Micro?", "product_overview.html#product_overview_intro", [
        [ "RTI Connext DDS Cert versus RTI Connext DDS Micro", "product_overview.html#overview_cert", null ],
        [ "Optional Certification Package", "product_overview.html#overview_cert_cdp", null ],
        [ "Publish-Subscribe Middleware", "product_overview.html#overview_intro_ps", null ],
        [ "Other Connext Products", "product_overview.html#overview_intro_other", null ]
      ] ],
      [ "Supported DDS Features", "product_overview.html#overview_features", [
        [ "DDS Entity Support", "product_overview.html#overview_features_dds_ent", null ],
        [ "DDS QoS Policy Support", "product_overview.html#overview_supported_qos", null ]
      ] ],
      [ "Programming Languages Support", "product_overview.html#overview_langs", null ],
      [ "RTI Supported Platforms", "product_overview.html#overview_platforms", [
        [ "Linux Supported Platform", "product_overview.html#rl_platform_linux", null ],
        [ "Windows Supported Platforms", "product_overview.html#rl_platform_windows", null ],
        [ "VxWorks Supported Platforms", "product_overview.html#rl_platform_vxworks", null ]
      ] ],
      [ "Buildable Source", "product_overview.html#overview_build_src", null ],
      [ "Standards and Interoperability", "product_overview.html#overview_stds", [
        [ "DDS Wire Compatability", "product_overview.html#overview_stds_rtps", null ],
        [ "Qos Policy Support", "product_overview.html#overview_stds_qos", null ],
        [ "DDS API Support", "product_overview.html#overview_stds_api", null ],
        [ "Application Binary Interface Compatibility", "product_overview.html#overview_stds_abi", null ]
      ] ]
    ] ],
    [ "Getting Started", "getting_started.html", [
      [ "Install RTI Connext DDS Micro", "getting_started.html#gs_install", [
        [ "Installing on a Windows System", "getting_started.html#rl_install_windows", null ],
        [ "Installing on a UNIX-Based System", "getting_started.html#rl_install_unix", null ],
        [ "Unpacking Buildable Source", "getting_started.html#rl_install_source", null ],
        [ "Environment", "getting_started.html#rl_install_env", null ]
      ] ],
      [ "Define a Data Type", "getting_started.html#gs_typegen", null ],
      [ "Generate Type Support Code with rtiddsgen", "getting_started.html#gs_rtiddsgen", null ],
      [ "Create an Application", "getting_started.html#gs_create_app", [
        [ "Registry Configuration", "getting_started.html#gs_registry", null ]
      ] ],
      [ "Configuring UDP Transport", "getting_started.html#gs_udp", null ],
      [ "Create DomainParticipant, Topic, and Type", "getting_started.html#gs_participant", [
        [ "Register Type", "getting_started.html#gs_participant_type", null ],
        [ "Create Topic of Registered Type", "getting_started.html#gs_participant_topic", null ],
        [ "DPSE Discovery: Assert Remote Participant", "getting_started.html#gs_participant_dpse", null ]
      ] ],
      [ "Create Publisher", "getting_started.html#gs_pub", null ],
      [ "Create DataWriter", "getting_started.html#gs_writer", [
        [ "DPSE Discovery: Assert Remote Subscription", "getting_started.html#gs_writer_dpse", null ],
        [ "Writing Samples", "getting_started.html#gs_writer_write", null ]
      ] ],
      [ "Create Subscriber", "getting_started.html#gs_sub", null ],
      [ "Create DataReader", "getting_started.html#gs_reader", [
        [ "DPSE Discovery: Assert Remote Publication", "getting_started.html#gs_reader_dpse", null ],
        [ "Receiving Samples", "getting_started.html#gs_reader_receive", null ],
        [ "Filtering Samples", "getting_started.html#gs_reader_filter", null ]
      ] ]
    ] ],
    [ "Introduction to DDS", "new_to_dds.html", [
      [ "RTI Connext DDS Documentation", "new_to_dds.html#rti_doc_intro", null ],
      [ "OMG DDS Specification", "new_to_dds.html#omg_dds_spec", null ]
    ] ],
    [ "Examples", "example_code.html", null ],
    [ "Release Notes", "rl_main.html", [
      [ "2.4.11", "rl_main.html#rl_24110", [
        [ "What's New", "rl_main.html#rl_new_24110", [
          [ "Support for ThreadX/NetX / Batching (reception only) / UDP Transformations", "rl_main.html#rl_new_24110_new_features", null ],
          [ "Optionally exclude builtin UDP Transport from compilation", "rl_main.html#rl_new_24110_MICRO-1805", null ],
          [ "Publication handle of DataWriter now provided upon DataReaderListener sample loss", "rl_main.html#rl_new_24110_MICRO-1800", null ],
          [ "DataWriters offer TOPIC presentation", "rl_main.html#rl_new_24110_MICRO-1747", null ],
          [ "New warning if a configured UDP transport does not have any interface", "rl_main.html#rl_new_24110_MICRO-1630", null ]
        ] ],
        [ "What's Fixed", "rl_main.html#rl_fixed_24110", [
          [ "Incorrect thread ID returned for VxWorks RTP", "rl_main.html#rl_fixed_24110_MICRO-1814", null ],
          [ "NULL listener and non-empty status mask not allowed for C++ DataReader", "rl_main.html#rl_new_24110_MICRO-1807", null ],
          [ "accept_unknown_peers did not work when Shared Memory transport was enabled in RTI Connext DDS Pro", "rl_main.html#rl_new_24110_MICRO-1798", null ],
          [ "Calling FooSeq_set_maximum() repeatedly with the same maximum size results in seg-fault", "rl_main.html#rl_new_24110_MICRO-1786", null ],
          [ "CMake reports error if CMake version 2.8.10.2 or 2.8.10.1 is used", "rl_main.html#rl_new_24110_MICRO-1748", null ],
          [ "OS error code (errno) not logged if sendto() returned error", "rl_main.html#rl_new_24110_MICRO-1712", null ],
          [ "Codegen might generate an incorrect pub/sub example if opction \"-create typefiles\" is not used", "rl_main.html#rl_new_24110_MICRO-1696", null ],
          [ "Generated examples use always the last structure in the idl", "rl_main.html#rl_new_24110_MICRO-1694", null ],
          [ "Instance might not have been disposed or unregistered under some conditions", "rl_main.html#rl_new_24110_MICRO-1692", null ],
          [ "Reliable Endpoints with only multicast locators may not communicate", "rl_main.html#rl_new_24110_MICRO-1687", null ],
          [ "Access to DDSEntity instance handles from C++ API", "rl_main.html#rl_new_24110_MICRO-1681", null ],
          [ "Syntax changed for initial peer participant index range", "rl_main.html#rl_new_24110_MICRO-1680", null ],
          [ "lookup_instance() is not thread safe", "rl_main.html#rl_new_24110_MICRO-1679", null ],
          [ "CMakeLists.txt and README.txt created when they should not", "rl_main.html#rl_new_24110_MICRO-1673", null ],
          [ "No communication when DomainParticipant used same GUID as another DomainParticipant in different domain", "rl_main.html#rl_new_24110_MICRO-1671", null ],
          [ "Compiler error might happen when lwIP is used", "rl_main.html#rl_new_24110_MICRO-1664", null ],
          [ "Wrong C++ code generated for unkeyed types when using IDL modules and -namespace option", "rl_main.html#rl_new_24110_MICRO-1663", null ],
          [ "DDS_WaitSet_wait does not work if OSAPI_Semaphore_take() returns an error", "rl_main.html#rl_new_24110_MICRO-1658", null ],
          [ "Log buffer could overflow on 64-bit architectures, causing application crash", "rl_main.html#rl_new_24110_MICRO-1657", null ],
          [ "Fix API realloc in Windows OSAPI", "rl_main.html#rl_new_24110_MICRO-1655", null ],
          [ "New samples for an instance may not be received if an instance goes back to ALIVE when using read()", "rl_main.html#rl_new_24110_MICRO-1651", null ],
          [ "INTRA transport caused subscription matches to use additional resources", "rl_main.html#rl_new_24110_MICRO-1650", null ],
          [ "Resolved memory leak in class RTRegistry", "rl_main.html#rl_new_24110_MICRO-1637", null ],
          [ "Windows Debug DLLs are built without debug information", "rl_main.html#rl_new_24110_MICRO-1634", null ],
          [ "Use hardcoded build ID when not compiling with CMake", "rl_main.html#rl_new_24110_MICRO-1632", null ],
          [ "Example makefiles do not support 64bit compilation", "rl_main.html#rl_new_24110_MICRO-1628", null ],
          [ "Compilation error might happen when code is generated using option -namespace", "rl_main.html#rl_new_24110_MICRO-1620", null ]
        ] ],
        [ "Known Issues", "rl_main.html#rl_known_24110", [
          [ "Maximum Number of Components Limited to 58", "rl_main.html#rl_known_24110_climit", null ],
          [ "CMake version 3.6 or Higher is Required to Build VxWorks with CMake", "rl_main.html#rl_known_24110_cmake", null ],
          [ "Static Endpoint Discovery Requires Unique Object IDs Across All Remote Endpoints", "rl_main.html#rl_known_24110_1553", null ],
          [ "Compiler warnings on VxWorks", "rl_main.html#rl_known_24110_warnings", null ],
          [ "OSAPI Does Not Always Detect Endianess", "rl_main.html#rl_known_24110_endianess", null ]
        ] ]
      ] ],
      [ "2.4.10.4", "rl_main.html#rl_24104", [
        [ "Backwards Compatibility", "rl_main.html#rl_bc_24104", [
          [ "Change in on_before_sample_deserialize callback.", "rl_main.html#rl_bc_24104_1711", null ]
        ] ],
        [ "What's New", "rl_main.html#rl_new_24104", [
          [ "Batching (reception only)", "rl_main.html#rl_new_24104_1711", null ],
          [ "C++ examples", "rl_main.html#rl_new_24104_1623", null ]
        ] ],
        [ "What's Fixed", "rl_main.html#rl_fixed_24104", [
          [ "Improve KEEP_LAST", "rl_main.html#rl_new_24104_MICRO-1754", null ],
          [ "Locator might be duplicated when NAT is configured", "rl_main.html#rl_new_24104_MICRO-1756", null ],
          [ "Segmentation fault might happen when a DataReader cannot be created", "rl_main.html#rl_new_24104_MICRO-1755", null ],
          [ "CMake reports error if CMake version 2.8.10.2 or 2.8.10.1 is used", "rl_main.html#rl_new_24104_MICRO-1748", null ],
          [ "Wrong TUDP locator kind sent when using UDP transformations", "rl_main.html#rl_new_24104_MICRO-1685", null ],
          [ "Compile shipped examples for a 64 bits architecture", "rl_main.html#rl_new_24104_MICRO-1628", null ],
          [ "OSAPI_Heap_realloc() Windows implementation fixed", "rl_main.html#rl_new_24104_MICRO-1655", null ],
          [ "Use API DDSDomainParticipant::delete_contained_entities() in C++ examples", "rl_main.html#rl_new_24104_MICRO-1656", null ],
          [ "Memory leak in shipped examples fixed", "rl_main.html#rl_new_24104_MICRO-1676", null ],
          [ "C++ shipped examples might release an object twice.", "rl_main.html#rl_new_24104_MICRO-1677", null ]
        ] ],
        [ "Known Issues", "rl_main.html#rl_known_24104", [
          [ "Maximum Number of Components Limited to 58", "rl_main.html#rl_known_24104_climit", null ],
          [ "CMake version 3.6 or Higher is Required to Build VxWorks with CMake", "rl_main.html#rl_known_24104_cmake", null ],
          [ "Static Endpoint Discovery Requires Unique Object IDs Across All Remote Endpoints", "rl_main.html#rl_known_24104_1553", null ],
          [ "Compiler warnings on VxWorks", "rl_main.html#rl_known_24104_warnings", null ],
          [ "OSAPI Does Not Always Detect Endianess", "rl_main.html#rl_known_24104_endianess", null ]
        ] ]
      ] ],
      [ "2.4.10.1", "rl_main.html#rl_24101", [
        [ "What's New", "rl_main.html#rl_new_24101", [
          [ "UDP Transformations", "rl_main.html#rl_new_24101_1631", null ]
        ] ],
        [ "What's Fixed", "rl_main.html#rl_fixed_24101", [
          [ "Race Condition when Log Buffer is Full and a Custom Log-handler is Installed", "rl_main.html#rl_new_24101_1641", null ]
        ] ],
        [ "Known Issues", "rl_main.html#rl_known_24101", [
          [ "Maximum Number of Components Limited to 58", "rl_main.html#rl_known_24101_climit", null ],
          [ "CMake version 3.6 or Higher is Required to Build VxWorks with CMake", "rl_main.html#rl_known_24101_cmake", null ],
          [ "Static Endpoint Discovery Requires Unique Object IDs Across All Remote Endpoints", "rl_main.html#rl_known_24101_1553", null ],
          [ "Compiler warnings on VxWorks", "rl_main.html#rl_known_24101_warnings", null ],
          [ "OSAPI Does Not Always Detect Endianess", "rl_main.html#rl_known_24101_endianess", null ]
        ] ]
      ] ],
      [ "2.4.10", "rl_main.html#rl_2410", [
        [ "What's New", "rl_main.html#rl_new_2410", [
          [ "Generate Example Application with rtiddsgen", "rl_main.html#rl_new_2410_1540", null ],
          [ "BY_SOURCE_TIMESTAMP_DESTINATIONORDER Support on DataWriter", "rl_main.html#rl_new_2410_1597", null ]
        ] ],
        [ "What's Fixed", "rl_main.html#rl_fixed_2410", [
          [ "Linker Warning for Missing PDB Files", "rl_main.html#rl_fixed_2410_1556", null ],
          [ "Linking with Dynamic Windows C Run-Time (CRT)", "rl_main.html#rl_fixed_2410_1572", null ],
          [ "DDS_Publisher_create_datawriter() May Fail to Create a New Datawriter", "rl_main.html#rl_fixed_2410_1579", null ],
          [ "DataReader May Not Reclaim NOT_ALIVE Instances when DataWriter Deleted or Liveliness Lost", "rl_main.html#rl_fixed_2410_1580", null ],
          [ "A Datawriter may fail to release instance resources if a peer is inactive while the Participant liveliness expires", "rl_main.html#rl_fixed_2410_1581", null ],
          [ "A Reliable DataWriter With max_samples_per_instance = 1 May Run Out of Resources After Multiple Unregistrations of Single Instance", "rl_main.html#rl_fixed_2410_1583", null ],
          [ "Connext Micro Fails to Discover Endpoints created by Connext Core if the Endpoints are Deleted or Modified", "rl_main.html#rl_fixed_2410_1588", null ],
          [ "Incorrect Log Output in a Complete Log Message could not be Stored", "rl_main.html#rl_fixed_2410_1589", null ],
          [ "Possible Segmentation Fault when Unregistering TRANSIENT_LOCAL Instance", "rl_main.html#rl_fixed_2410_1590", null ],
          [ "Support to map IDL modules to C++ namespaces in generated type-plugins", "rl_main.html#rl_fixed_2410_1600", null ],
          [ "Possible Memory Access Violation when Receiving Malformed RTPS Message", "rl_main.html#rl_fixed_2410_1614", null ],
          [ "In Some Cases an Incorrect Timeout Calculation Caused 100% CPU Load", "rl_main.html#rl_fixed_2410_1617", null ]
        ] ],
        [ "Known Issues", "rl_main.html#rl_known_2410", [
          [ "CMake version 3.6 or Higher is Required to Build VxWorks with CMake", "rl_main.html#rl_known_2410_cmake", null ],
          [ "Static Endpoint Discovery Requires Unique Object IDs Across All Remote Endpoints", "rl_main.html#rl_known_2410_1553", null ],
          [ "Compiler warnings on VxWorks", "rl_main.html#rl_known_2410_warnings", null ],
          [ "OSAPI Does Not Always Detect Endianess", "rl_main.html#rl_known_2410_endianess", null ]
        ] ]
      ] ],
      [ "2.4.9", "rl_main.html#rl_249", [
        [ "What's New", "rl_main.html#rl_new_249", [
          [ "Improved Support for adding new Ports", "rl_main.html#rl_new_249_porting", null ],
          [ "Updated Build Environment to Build RTI Connext Micro", "rl_main.html#rl_new_249_source", null ],
          [ "Example CMake Tool-chain Files for Cross-Compilation", "rl_main.html#rl_new_249_706", null ],
          [ "Host Bundle without the Java RunTime Available", "rl_main.html#rl_new_249_1520", null ],
          [ "Support for 64-bit Platforms", "rl_main.html#rl_new_249_1559", null ],
          [ "POSIX Compliance Improvements", "rl_main.html#rl_new_249_1548", null ],
          [ "C++ Support for find_topic()", "rl_main.html#rl_new_249_1551", null ],
          [ "Types Are Automatically Unregistered Upon Deleting Contained Entities", "rl_main.html#rl_new_249_1569", null ]
        ] ],
        [ "What's Fixed", "rl_main.html#rl_fixed_249", [
          [ "Improved Documentation", "rl_main.html#rl_fixed_249_711", null ],
          [ "Losing Participant Liveliness Stops Communication", "rl_main.html#rl_fixed_249_1543", null ],
          [ "DDSTopic::narrow() Returned Incorrect Value in C++", "rl_main.html#rl_fixed_249_1544", null ],
          [ "PRECONDITION_NOT_MET Returned by deleted_topic() When Topic Is Not Use", "rl_main.html#rl_fixed_249_1545", null ],
          [ "Instance Resources Not Reclaimed When Unregistered", "rl_main.html#rl_fixed_249_1546", null ],
          [ "Invalid Memory Read Reported in Log.c", "rl_main.html#rl_fixed_249_1550", null ],
          [ "Unsupported Functions When Compiling With RTI_CERT Has Been Removed From Generated Code", "rl_main.html#rl_fixed_249_1558", null ],
          [ "The HelloWorld_cert Example Now Compiles When Linked Against a Library Built With RTI_CERT", "rl_main.html#rl_fixed_249_1561", null ],
          [ "Hostnames Are No Longer Validated", "rl_main.html#rl_fixed_249_1563", null ],
          [ "A Participant May Not Be Rediscovered In Case Of Asymmetric Liveliness Loss", "rl_main.html#rl_fixed_249_1571", null ],
          [ "A Non-keyed Endpoint Matches a Keyed Endpoint", "rl_main.html#rl_fixed_249_1574", null ]
        ] ],
        [ "Known Issues", "rl_main.html#rl_known_249", [
          [ "Static Endpoint Discovery Requires Unique Object IDs Across All Remote Endpoints", "rl_main.html#rl_known_249_1553", null ],
          [ "Deprecated Windows APIs Used by RTI Connext Micro", "rl_main.html#rl_known_249_1575", null ],
          [ "Compiler warnings on VxWorks", "rl_main.html#rl_known_249_warnings", null ],
          [ "OSAPI Does Not Always Detect Endianess", "rl_main.html#rl_known_249_endianess", null ]
        ] ]
      ] ],
      [ "2.4.8", "rl_main.html#rl_248", [
        [ "What's New", "rl_main.html#rl_new_248", null ],
        [ "What's Fixed", "rl_main.html#rl_fixed_248", [
          [ "Consistent support for assignment operator in C++", "rl_main.html#rl_new_247_1541", null ],
          [ "DPSE API renamed to avoid conflict with assert()", "rl_main.html#rl_new_247_1539", null ]
        ] ]
      ] ]
    ] ],
    [ "Manuals", "modules.html", "modules" ]
  ] ]
];

var NAVTREEINDEX =
[
"example_code.html",
"group__DDSCLogCodesClass.html#gaa386a9849aa9dc554890f346a6b7f433",
"group__DDSEntityFactoryQosModule.html",
"group__DDSSequenceModule.html#gaed2da23ace969a6556f2870a4381e350",
"group__DPDELogCodesClass.html#ga9be76e2fb63b5207430dbcb993216db4",
"group__OSAPILogCodesClass.html#ga9000d76bb20e69ac3bc762d3daaf9de3",
"group__RTPSLogCodesClass.html#ga3db2727b8cd62ff59ac0e398747de7dc",
"rl_main.html#rl_known_24110_1553",
];

var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  if (node.parentNode && node.parentNode.parentNode) {
    createIndent(o,domNode,node.parentNode,level+1);
  }
  var imgNode = document.createElement("img");
  imgNode.width = 16;
  imgNode.height = 22;
  if (level==0 && node.childrenData) {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        if (node.isLast) {
          node.plus_img.src = node.relpath+"ftv2plastnode.png";
        } else {
          node.plus_img.src = node.relpath+"ftv2pnode.png";
        }
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
  } else {
    domNode.appendChild(imgNode);
  }
  if (level==0) {
    if (node.isLast) {
      if (node.childrenData) {
        imgNode.src = node.relpath+"ftv2plastnode.png";
      } else {
        imgNode.src = node.relpath+"ftv2lastnode.png";
        domNode.appendChild(imgNode);
      }
    } else {
      if (node.childrenData) {
        imgNode.src = node.relpath+"ftv2pnode.png";
      } else {
        imgNode.src = node.relpath+"ftv2node.png";
        domNode.appendChild(imgNode);
      }
    }
  } else {
    if (node.isLast) {
      imgNode.src = node.relpath+"ftv2blank.png";
    } else {
      imgNode.src = node.relpath+"ftv2vertline.png";
    }
  }
  imgNode.border = "0";
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : '#';
      a.onclick = function(){
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var pos, anchor = $(aname), docContent = $('#doc-content');
        if (anchor.parent().attr('class')=='memItemLeft') {
          pos = anchor.parent().position().top;
        } else if (anchor.position()) {
          pos = anchor.position().top;
        }
        if (pos) {
          var dist = Math.abs(Math.min(
                     pos-docContent.offset().top,
                     docContent[0].scrollHeight-
                     docContent.height()-docContent.scrollTop()));
          docContent.animate({
            scrollTop: pos + docContent.scrollTop() - docContent.offset().top
          },Math.max(50,Math.min(500,dist)),function(){
            window.location.replace(aname);
          });
        }
      };
    } else {
      a.href = url;
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var anchor = $($(location).attr('hash'));
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
}

function selectAndHighlight(n)
{
  var a;
  if ($(location).attr('hash')) {
    var link=stripPath($(location).attr('pathname'))+':'+
      $(location).attr('hash').substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  showRoot();
}

function showNode(o, node, index)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).show();
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index); // retry with child node expanded
          },true);
        } else {
          var rootBase = o.toroot.replace(/\..+$/, '');
          if (rootBase=="index" || rootBase=="pages") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(n);
        }
      }
    }
  } else {
    selectAndHighlight();
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = nti ? nti : navTreeSubIndices[subIndex][root];
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0);
  }
}

function navTo(o,root,hash,relpath)
{
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  navTo(o,toroot,window.location.hash,relpath);

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     }
  })

  $(window).load(showRoot);
}

